<?php

/**
 * cierre_contrato_mes actions.
 *
 * @package    nomina
 * @subpackage cierre_contrato_mes
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class cierre_contrato_mesActions extends sfActions {

    /**
     * Metodo que trae nombramientos que se terminan en elsiguiente mes del periodo de filtro
     *
     * @param sfWebRequest $request
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------/  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        //manejo de errores
        try {

            /*
             * Variables obligatorias
             */
            $id_periodo = $request['id_periodo'];


            /*
             * Variables opcionales
             */
            //Funcionario num_doc
            $num_doc = null;
            $whereFuncionarioNumDoc = "";
            if (isset($request['num_doc'])) {
                $num_doc = $request['num_doc'];
                $whereFuncionarioNumDoc = " AND num_doc = " . $request['num_doc'];
            }
            //Funcionario id_tipo_doc 
            $id_tipo_doc = null;
            $whereFuncionarioTipoDoc = "";
            if (isset($request['id_tipo_doc'])) {
                $id_tipo_doc = $request['id_tipo_doc'];
                $whereFuncionarioTipoDoc = " AND id_tipo_doc = " . $request['id_tipo_doc'];
            }


            /*
             * Paginacion
             */
            if (isset($request['_startRow'])) {
                $rowStart = $request['_startRow'];
            } else {
                $rowStart = 0;
            }

            if (isset($request['_endRow'])) {
                $rowEnd = $request['_endRow'];
            } else {
                $rowEnd = 75;
            }

            /*
             * Formato de fecha sin time
             */
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;

            CN_TABLE::executeSQL($sql);

            /**
             * Alerta: En el proceso de Liquidación de nómina: Mostrar funcionarios a los que se les termina el 
             * contrato en el PERIODO QUE SE ESTA EJECUTANDO, sin bloquear la liquidación de la nómina mensual, 
             * solo como recordatorio de que tiene fecha de Terminación y no hay novedad de retiro.
             */
            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            $sql = <<<EOD

select count(*) as count from (
--prorroga de contrato

select
(select  id_anhos ||'-'|| lpad(id_meses,2,'0') || '-01' from no_periodo where id_periodo = $id_periodo )  as fecha,
$id_periodo as id_periodo,
id_nombramiento,
ID_TIPO_DOC,
num_doc,
contrato,
fecha_ingreso,
fecha_termina,
ESTADO
from no_nombramiento
where 
estado = 1
$whereFuncionarioNumDoc $whereFuncionarioTipoDoc 
and fecha_retiro is null
and trunc(fecha_termina) between to_date( (select   id_anhos||'-'||lpad(id_meses,2,'0')  from no_periodo where id_periodo = $id_periodo) || '-01' ,'YYYY-MM-DD')  
    and trunc(last_day( to_date( (select   id_anhos||'-'||lpad(id_meses,2,'0')  from no_periodo where id_periodo = $id_periodo) || '-01' ,'YYYY-MM-DD')  )) 

)

EOD;


            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];

            /*
             * consulta para determinar nombramientos para el periodo creado
             */
            $sql = <<<EOD

SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (
                    
select
(select  id_anhos ||'-'|| lpad(id_meses,2,'0') || '-01' from no_periodo where id_periodo = $id_periodo )  as fecha,
$id_periodo as id_periodo,
id_nombramiento,
ID_TIPO_DOC,
num_doc,
contrato,
fecha_ingreso,
fecha_termina,
ESTADO
from no_nombramiento
where 
estado = 1
$whereFuncionarioNumDoc $whereFuncionarioTipoDoc 
and fecha_retiro is null
and trunc(fecha_termina) between to_date( (select   id_anhos||'-'||lpad(id_meses,2,'0')  from no_periodo where id_periodo = $id_periodo) || '-01' ,'YYYY-MM-DD')  
    and trunc(last_day( to_date( (select   id_anhos||'-'||lpad(id_meses,2,'0')  from no_periodo where id_periodo = $id_periodo) || '-01' ,'YYYY-MM-DD')  )) 

            
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart

EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow = $this->startRow + count($resultado);
            $this->list_data = $resultado;

            if (count($resultado) > 0) {
                $this->status = 2;
            }
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
